$APPTYPE CONSOLE: $TYPECHECK ON
$RESOURCE hot_ico As "hotbasic.ico"
DIM Reg AS REGISTRY
DIM HKEY As DWORD, curkey as DWORD
HKEY= &H80000001

DEFSTR r$,c$,t$,key$,k$,v$,blank = SPACE$(80)
DEFLNG i,j,k,n,s,keycode
DIM KI(15) As LONG  'remember last key item
t$="HotBasic(tm) REGISTRY Object Walk-Through 1.5"
SETCONSOLETITLE t$

NextKey:
Reg.RootKey = HKEY
Reg.OpenKey(key$,0)

ShowKeyItem:
CLS
COLOR 10,0
PRINT "Navigate Registry with arrow keys (TAB changes .RootKey; ESC exits)"
GOSUB ShowReg

GetKeyCmd:
i=Console.Event
IF i=1 AND Console.KeyDown THEN

keycode=console.KeyCode

SELECT CASE keycode

'exit with ESC
CASE 27: Goto TheEnd

'tab
CASE 9
Reg.CloseKey
i=HKEY AND 7: INC(i)
IF i>7 THEN i=0
HKEY=&H80000000 OR i
s=0: k=0: key$=NULL: k$=NULL: Goto NextKey

'up
CASE 38,104
IF k>0 THEN DEC(k): Goto ShowKeyItem

'down
CASE 40,98
IF k<Reg.KeyItemCount-1 THEN INC(k): Goto ShowKeyItem

'left
CASE 37,100
IF key$<>NULL THEN
  r$=REVERSE$(key$): i=INSTR(r$,"\")
  IF i THEN
    j=key$.length: key$=LEFT$(key$,j-i)
  ELSE
    key$=NULL
  END IF
END IF
IF s THEN DEC(s)
k=KI(s): Reg.CloseKey: Goto NextKey

'right
CASE 39,102
i=Reg.KeyItemCount
IF i>0 THEN 
  KI(s)=k: INC(s)
  IF key$<>NULL THEN key$=key$+"\"+k$ ELSE key$=k$
  k=0: Reg.CloseKey: Goto NextKey
END IF

'delete "D"
CASE 68
'Reg.CloseKey
'Reg.OpenKey(key$,1)
'i=Reg.DeleteKey(key$)
PRINT key$+" deleted with ret = "+STR$(i)
pause

END SELECT
END IF
Sleep 0.3: Goto GetKeyCmd

TheEnd:
Reg.CloseKey
END

ShowReg:
curkey=Reg.CurrentKey
IF Reg.HasSubKeys THEN k$=Reg.KeyItem(k)
COLOR 11,0
GOSUB ShowPath
PRINT ".Class=";Reg.Class
COLOR 7,0

PRINT ".RootKey (hex) =";HEX$(Reg.RootKey);
LOCATE CSRLIN,26: PRINT ".CurrentKey    =";curkey;
LOCATE CSRLIN,53: PRINT ".Error       =";Reg.Error

PRINT ".KeyItemCount  =";Reg.KeyItemCount;
LOCATE CSRLIN,26: PRINT ".ValueItemCount=";Reg.ValueItemCount;
LOCATE CSRLIN,53: PRINT ".Index       =";k  'Reg.Index

IF Reg.HasSubKeys THEN
  COLOR 0,7
  PRINT "KeyItem                       Class                                ";
  COLOR 13,0: PRINT
  PRINT k$;: LOCATE CSRLIN,31: PRINT Reg.Class;
  COLOR 7,0: PRINT
END IF

'$DEFINE REG_NONE 0
'$DEFINE REG_SZ 1
'$DEFINE REG_EXPAND_SZ 2
'$DEFINE REG_BINARY 3
'$DEFINE REG_DWORD 4
'$DEFINE REG_DWORD_LITTLE_ENDIAN 4
'$DEFINE REG_DWORD_BIG_ENDIAN 5
'$DEFINE REG_LINK 6
'$DEFINE REG_MULTI_SZ 7
'$DEFINE REG_RESOURCE_LIST 8

IF Reg.ValueItemCount THEN
  GOSUB ClearItems
  FOR i=0 to Reg.ValueItemCount-1
  v$=Reg.ValueItem(i): j=CSRLIN
  PRINT Reg.Name;
  LOCATE j,26: PRINT Reg.Type;
  LOCATE j,31: COLOR 12,0 
  SELECT CASE Reg.Type  'In HB, .Type = .GetDataType
    CASE 0: PRINT "no value"
    CASE 1,2,7: PRINT Reg.Value
'notice v$ can hold text strings or binary strings!
    CASE 4: PRINT Reg.Dword
    CASE 6: PRINT v$
    CASE ELSE
      IF Reg.GetDataSize>256 THEN
        PRINT "Value length = ";Reg.GetDataSize;
      ELSE
        FOR j=1 to v$.length: c$=v$[j]: n=ASC(c$)
        c$=RIGHT$(HEX$(n),2): PRINT c$;SPACE;: NEXT j
      END IF
      PRINT 
  END SELECT
  COLOR 7,0
  IF CSRLIN>18 THEN PAUSE: GOSUB ClearItems
  NEXT i
END IF
LOCATE 7,1
RETURN

ShowPath:
PRINT ".Path =";
c$=Reg.Path
IF c$.length>72 THEN c$="..."+RIGHT$(c$,69)
PRINT c$
RETURN

ClearItems:
FOR n=8 to 24: LOCATE n,1: PRINT blank;: NEXT n
LOCATE 8,1: COLOR 0,7
PRINT "Name                     Type Value                                ";
COLOR 7,0: PRINT
RETURN
